// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "AssetManager.hpp"

#if !defined(DAWN_ASSET_BUILD_PREFIX)
  #error Asset Prefix has not been defined.
#endif

using namespace Dawn;

void AssetManager::init() {

}

void AssetManager::update() {
  auto it = this->assetsNotLoaded.begin();
  while(it != this->assetsNotLoaded.end()) {
    auto asset = it->second;
    if(asset->loaded) {
      it = this->assetsNotLoaded.erase(it);
      continue;
    }

    asset->updateSync();
    asset->updateAsync();

    if(asset->loaded) {
      it = this->assetsNotLoaded.erase(it);
      continue;
    }

    ++it;
  }
}