// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "../Asset.hpp"
#include "../AssetLoader.hpp"
#include "display/font/TrueTypeFont.hpp"

namespace Dawn {
  class TrueTypeAsset : public Asset {
    protected:
      AssetLoader loader;
      uint8_t *buffer = nullptr;
      truetypechar_t *characterData = nullptr;
      struct Color *pixels = nullptr;
      int32_t width, height;

    public:
      TrueTypeFont font;

      TrueTypeAsset(AssetManager &assMan, std::string name);

      void updateSync() override;
      void updateAsync() override;

      ~TrueTypeAsset();
  };
}