// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/Color.hpp"

namespace Dawn {
  class ITexture {
    public:
      virtual int32_t getWidth() = 0;
      virtual int32_t getHeight() = 0;
      virtual void setSize(int32_t width, int32_t height) = 0;
      virtual void fill(struct Color) = 0;
      virtual bool_t isReady() = 0;
      virtual void buffer(struct Color pixels[]) = 0;
  };
}