/**
 * Copyright (c) 2022 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/mesh/Mesh.hpp"
#include "util/mathutils.hpp"
#include "display/Texture.hpp"
#include "display/mesh/QuadMesh.hpp"
#include "FontMeasure.hpp"

#define FONT_NEWLINE '\n'
#define FONT_SPACE ' '

namespace Dawn {
  class Font {
    public:
      virtual void buffer(
        std::string text,
        float_t fontSize,
        float_t maxWidth,
        Mesh &mesh,
        struct FontMeasure *info
      ) = 0;

      virtual Texture & getTexture() = 0;
      virtual void draw(Mesh &mesh, int32_t startCharacter, int32_t length) = 0;
      virtual float_t getLineHeight(float_t fontSize) = 0;
      virtual float_t getDefaultFontSize() = 0;
  };
}