// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "FontMeasure.hpp"

using namespace Dawn;

float_t FontMeasure::getWidth() {
  return this->width;
}

float_t FontMeasure::getHeight() {
  return this->height;
}

int32_t FontMeasure::getQuadCount() {
  return this->realLength;
}

size_t FontMeasure::getLineCount() {
  return this->lines.size();
}

int32_t FontMeasure::getQuadsOnLine(int32_t line) {
  return this->lines[line].length;
}

int32_t FontMeasure::getQuadIndexOnLine(int32_t line) {
  return this->lines[line].start;
}

void FontMeasure::addLine(int32_t start, int32_t len) {
  struct FontLineMeasure info;
  info.start = start;
  info.length = len;
  this->lines.push_back(info);
}