// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIComponent.hpp"
#include "display/mesh/QuadMesh.hpp"
#include "display/Texture.hpp"

namespace Dawn {
  class UIBorder : public UIComponent {
    private:
      Mesh mesh;
      glm::vec2 edgeDimensions = glm::vec2(8.0f, 8.0f);
      glm::vec2 uv0 = glm::vec2(0.0f, 0.0f);
      glm::vec2 uv1 = glm::vec2(1.0f, 1.0f);

      void updatePositions() override;

    public:
      Texture *texture;
      
      UIBorder(UICanvas &canvas);
      void drawSelf(UIShader &shader, glm::mat4 selfTransform) override;

      void setBorderSize(glm::vec2 borderSize);
      glm::vec2 getBorderSize();
  };
}